Skip to main content

Segment Tree -Question 1

Most Beautiful Item for Each Query

You are given a 2D integer array items where items[i] = [pricei, beautyi] denotes the price and beauty of an item respectively.

You are also given a 0-indexed integer array queries. For each queries[j], you want to determine the maximum beauty of an item whose price is less than or equal to queries[j]. If no such item exists, then the answer to this query is 0.

Return an array answer of the same length as queries where answer[j] is the answer to the jth query.

Constraints:

1 <= items.length, queries.length <= 10^5

items[i].length == 2

1 <= pricei, beautyi, queries[j] <= 10^9


Analysis:

The first step can be to sort the items based on the price. Then we can narrow down the search range by a binary search.

But the beauty is not sorted yet. So if without further treatment, we need to scan through the query range, the time complexity is O(N). The query length could be as large as 1e5, thus the overall time complexity is O(N*M) ~ 1e10, which is too large to this question.

If use a segment tree, then the time complexity can decrease to O(M*log(N)).

The key step is to save the beauty values with the original order to a helper array with a double size, then build up the maximum values in a way like building a maximum-root heap (see the code below).

After having the segment-tree array, the time complexity is O(log(N)) for one query. The overall time complexity is O(M*log(N)) for M queries.


See the code below:

class Solution {
public:
    vector<int> maximumBeauty(vector<vector<int>>& items, vector<int>& queries) {
        vector<int> res;
        sort(items.begin(), items.end(), [](auto &a, auto &b) {
            return a[0] < b[0]; 
        });
        int n = items.size();
        vector<int> data(2*n, 0);
        for(int i=n; i<2*n; ++i) data[i] = items[i-n][1];
        build(data);
        for(auto &a : queries) {
            int id = findUpperBound(items, a);
            //cout<<id<<endl;
            res.push_back(query(data, 0, id-1));
        }
        return res;
    }
private:
    int findUpperBound(vector<vector<int>>& its, int val) {
        int left = 0, right = its.size();
        while(left < right) {
            int mid = left + (right - left) / 2;
            //cout<<mid<<" "<<left<<" "<<right<<endl;
            if(its[mid][0] <= val) left = mid + 1;
            else right = mid;
        }
        return left;
    }
    void build(vector<int>& data) {
        int n = data.size();
        n /= 2;
        for(int i=n-1; i>0; --i) data[i] = max(data[2*i], data[2*i+1]);
    }
    int query(vector<int>& data, int left, int right) {
        if(left > right) return 0;
        int res = 0, m = data.size(), n = m/2;
        for(int i = left + n, j = right + n; i <= j; i /= 2, j /= 2) {
            if(i&1) res = max(res, data[i++]);
            if(!(j&1)) res = max(res, data[j--]);
        }
        return res;
    }
};


Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...